/*
 * To change this license header, choose License Headers in Project Properties.
 * To change this template file, choose Tools | Templates
 * and open the template in the editor.
 */

package mockaccountexample;

import static org.junit.Assert.assertEquals;
import static org.junit.Assert.assertTrue;
import junit.framework.JUnit4TestAdapter;
import org.jmock.Expectations;
import org.jmock.Mockery;
import org.jmock.integration.junit4.JMock;
import org.jmock.integration.junit4.JUnit4Mockery;
import org.junit.Before;
import org.junit.Test;
import org.junit.runner.RunWith;
import static org.junit.Assert.assertEquals;
import static org.junit.Assert.assertTrue;

import  bankingSystem.Account;
import  bankingSystem.CreditAccount;
 
@RunWith(JMock.class)
public class MockBankAccountTest 
{
    public static junit.framework.Test suite() 
    {
        return new JUnit4TestAdapter(MockBankAccountTest.class);
    }
 
    CreditAccount creditAcc;
    Mockery context = new JUnit4Mockery();
 
    Account accountHandler;
 
    @Before
    public void initialize() 
    {
        accountHandler = context.mock(Account.class);
        creditAcc = new CreditAccount(accountHandler);
    }
 
    @Test
    public void failExecutionIfBalanceInadequate() 
    {
        System.out.println("failExecutionIfBalanceInadequate");
        double  balance = 0;
        context.checking(new Expectations() 
        {
            {
                oneOf(accountHandler).getBalance();
                will(returnValue(0.00));
            }
        });
 
        balance = creditAcc.getBalance();
        assertEquals(0.0, balance, 0.0);
    }
 
    @Test
    public void executeWithdrawChangesBalanceAndSetsExecuted() 
    {
        System.out.println("executeWithdrawChangesBalanceAndSetsExecuted");
        double  balance = 0;
        
        context.checking(new Expectations() 
        {
            {
                oneOf(accountHandler).getBalance();
                will(returnValue(2500.00));
                
                oneOf(accountHandler).getBalance();
                will( returnValue(2500.00));
                oneOf(accountHandler).debit(with(1500.00));
                oneOf(accountHandler).getBalance();
                will( returnValue(1000.00));
            }
        });
 
        balance = creditAcc.getBalance();
        assertEquals( 2500.00, balance, 0.0 );
        balance = creditAcc.debit(1500.00);
        assertEquals( 1000.00, balance, 0.0 );
 
        assertEquals(true, creditAcc.isExecuted());
    }
 
    @Test
    public void methodThatWeExpectWillThrowAnException() 
    {
        System.out.println("methodThatWeExpectWillThrowAnException");
        boolean expectedThrown = false;
 
        try {
            throw new RuntimeException();
        } catch (RuntimeException e) {
            expectedThrown = true;
        }
 
        assertTrue(expectedThrown);
    }
}
